use std::path::{Path, PathBuf};



pub struct Util
{
   include_directories: Vec<PathBuf>
}



impl Util
{
   pub fn new() -> Util
   {
      Util
      {
         include_directories: Vec::new()
      }
   }

   pub fn register_include_dir(&mut self, dir: &Path)
   {
      let include_dir: PathBuf;

      include_dir = PathBuf::from(dir);

      self.include_directories.push(include_dir);
   }

   pub fn get_include_file_path(&self, filepath: &Path) -> Option<PathBuf>
   {
      let mut path: PathBuf;

      // Loop through and find the first path that exists
      // when combining it with the paths in the list of include
      // directories.
      for dir in self.include_directories.iter()
      {
         path = PathBuf::from(dir).join(filepath);
         if path.exists() == true
         {
            return Some(path);
         }
      }

      None
   }
}
